constant logic.eq_ : forall (A : Type) , (A) -> (A) -> Prop.
axiom logic.refl_ : forall (A : Type) , forall (x:A) , (((logic.eq_) (A)) (x)) (x).
axiom logic.eq_ind : forall (A : Type) , forall (x:A) , forall (P:(A) -> Prop) , ((P) (x)) -> forall (y:A) , ((((logic.eq_) (A)) (x)) (y)) -> (P) (y).
theorem logic.rewrite_l : forall (A : Type) , forall (x:A) , forall (P:(A) -> Prop) , ((P) (x)) -> forall (y:A) , ((((logic.eq_) (A)) (x)) (y)) -> (P) (y) := fun (A : Type) , fun (x : A) , fun (P : (A) -> Prop) , fun (Hx : (P) (x)) , (fun (y : A) , fun (Heq : (((logic.eq_) (A)) (x)) (y)) , (((((((@logic.eq_ind) (A)) (x)) (fun (__ : A) , (P) (__))) (Hx)) (y)) (Heq))).
theorem logic.sym_eq : forall (A : Type) , forall (x:A) , forall (y:A) , ((((logic.eq_) (A)) (x)) (y)) -> (((logic.eq_) (A)) (y)) (x) := fun (A : Type) , fun (x : A) , fun (y : A) , fun (Heq : (((logic.eq_) (A)) (x)) (y)) , (((((((@logic.rewrite_l) (A)) (x)) (fun (__ : A) , (((logic.eq_) (A)) (__)) (x))) (((@logic.refl_) (A)) (x))) (y)) (((((((@logic.rewrite_l) (A)) (x)) (fun (__ : A) , (((logic.eq_) (A)) (x)) (__))) (((@logic.refl_) (A)) (x))) (y)) (Heq))).
theorem logic.rewrite_r : forall (A : Type) , forall (x:A) , forall (P:(A) -> Prop) , ((P) (x)) -> forall (y:A) , ((((logic.eq_) (A)) (y)) (x)) -> (P) (y) := fun (A : Type) , fun (x : A) , fun (P : (A) -> Prop) , fun (Hx : (P) (x)) , (fun (y : A) , fun (Heq : (((logic.eq_) (A)) (y)) (x)) , (((((((@logic.eq_ind) (A)) (x)) (fun (__ : A) , (P) (__))) (Hx)) (y)) (((((@logic.sym_eq) (A)) (y)) (x)) (Heq)))).
theorem logic.eq_coerc : forall (A:Prop) , forall (B:Prop) , (A) -> ((((logic.eq_) (Prop)) (A)) (B)) -> B := fun (A : Prop) , fun (B : Prop) , fun (Ha : A) , (fun (Heq : (((logic.eq_) (Prop)) (A)) (B)) , (((((((@logic.eq_ind) (Prop)) (A)) (fun (x_19 : Prop) , x_19)) (Ha)) (B)) (Heq))).
